#include <acknex.h>
#include <default.c>
#define PRAGMA_PATH "@Bits"
///////////////////////////////////////////////

#include "pan3d_create.h"

///////////////////////////////////////////////

ENTITY* Player = {	layer=0;	}	//pretend player to store health's
#define health			skill1
#define max_health	skill2
#define mana			skill3
#define max_mana		skill4


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
FONT* Arial_12 = "Arial#12b";
BMAP* red_bar  = "red_bar.bmp";
BMAP* blue_bar ="blue_bar.bmp";
BMAP* mini_map = "mini_map.tga";
SOUND* chimes	= "chimes.wav";
SOUND* tada		= "tada.wav";
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
void close_panel(var butt, PANEL* pan)		{	reset(pan, SHOW);	}
//
// Enemy health-panel (solid-background) demo
action enemy_A_action()
{
	PANEL* mine = pan_create("size_x=60; size_y=30; flags=SHOW;",1);
	mine.bmap = bmap_createblack(60,30,24);	set(mine, NOFILTER|CENTER_X);
	BMAP* butt_off  = bmap_createblack(5,5,24);	bmap_fill(butt_off, vector(0,0,127), 100);
	BMAP* butt_over = bmap_createblack(5,5,24);	bmap_fill(butt_over, vector(0,127,0), 100);
	pan_setbutton(mine,0,1, 55,0, butt_off,butt_off,butt_over,0, close_panel,0,0);
	pan_setdigits(mine,0, 30,0, "Enemy-A", Arial_12, 0, 0);
	pan_setdigits(mine,0, 30,15, "%.0f", Arial_12, 1, my.skill1);
	my.skill1 = 360;
	//
	ENTITY* tmp = pan3d_create(mine, vector(-25,0,60), NULL, FOLLOW_ME|ORBIT_FOLLOW|FACE_FLAT);
	//
	while(1)			
	{
		my.pan = my.skill1 = cycle(my.skill1-time_step*2, 0, 360);
		wait(1);
	}
} 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Enemy health-panel (transparent-background) demo
action enemy_B_action()
{
	PANEL* mine = pan_create("size_x=60; size_y=30; flags=SHOW;",1);
	mine.bmap = bmap_createblack(60,30,32);	set(mine, OVERLAY|NOFILTER|CENTER_X);
	pan_setdigits(mine,0, 30,0, "Enemy-B", Arial_12, 0, 0);
	pan_setdigits(mine,0, 30,15, "%.0f", Arial_12, 1, my.skill1);
	my.skill1 = 500;		
	//
	ENTITY* tmp = pan3d_create(mine, vector(0,0,60), NULL, FOLLOW_ME|FACE_FLAT);
	//
	while(1)			
	{
		my.pan = my.skill1 = cycle(my.skill1-time_step*2, 0, 360);
		c_move(me, vector(time_step*3,0,0),NULL,NULL);
		wait(1);
	}
} 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Player health-bars GUI demo
action gui_A_action()
{
	while(!Player)	wait(1);
	Player.health = Player.max_health = 500;		Player.mana = Player.max_mana = 200;	
	PANEL* mine = pan_create("size_x=75; size_y=40; flags=SHOW;",1);	set(mine, CENTER_X);
	mine.bmap = bmap_createblack(75,40,32);	bmap_fill(mine.bmap, vector(27,127,27),100);
	pan_setdigits(mine,0, 30,0, "GUI-A", Arial_12, 0, 0);		
	pan_setdigits(mine,0, 65,12, "%.0f", Arial_12, 1, Player.skill1);
	pan_setwindow(mine,0,  2,15, 	50,10, red_bar, mine.skill_x,0);
	pan_setdigits(mine,0, 65,25, "%.0f", Arial_12, 1, Player.skill3);
	pan_setwindow(mine,0,  2,27, 	50,10, blue_bar, mine.skill_y,0);
	//
	me = pan3d_create(mine, ang_rotate(vector(0,0,0),vector(20,7.5,6.5)), NULL, FOLLOW_CAMERA|ORBIT_FOLLOW|FACE_FLAT);
	vec_fill(my.scale_x, 0.1);		my.material = mat_unlit;
	//
	while(1)			
	{
		Player.health = cycle(Player.health+time_step*5, 0, Player.max_health);
		Player.mana   = cycle(Player.mana+time_step*5, 0, Player.max_mana);
		mine.skill_x = 50-Player.health/Player.max_health*50;
		mine.skill_y = 50-Player.mana/Player.max_mana*50;
		wait(1);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Mini_map GUI "DISPLAY" demo   ((its just a static bmap for this demo))
action gui_B_action()
{
	while(!Player)	wait(1);
	PANEL* mine = pan_create("bmap=mini_map; flags=TRANSLUCENT | SHOW;",1);		mine.alpha=50;
	mine.center_x = mine.size_x/2;	mine.center_y = mine.size_y/2;	mine.skill_x = camera.pan;
	//
	me = pan3d_create(mine, ang_rotate(vector(0,0,0),vector(20,-9,6)), NULL, FOLLOW_CAMERA|ORBIT_FOLLOW|FACE_FLAT);
	vec_fill(my.scale_x, 0.05);		my.material = mat_unlit;			
	//
	while(1)			
	{
		mine.angle = camera.pan-mine.skill_x;
		wait(1);
	}
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void button_trigger_1()	{	snd_play(tada, 75, 0);		}
void button_trigger_2()	{	snd_play(chimes, 75, 0);	}

// Panel GUI with buttons demo
action gui_C_action()
{
	BMAP* butt_on   = bmap_createblack(10,10,24);	bmap_fill(butt_on, 	vector(0,127,0), 100);
	BMAP* butt_off  = bmap_createblack(10,10,24);	bmap_fill(butt_off, 	vector(0,0,127), 100);
	BMAP* butt_over = bmap_createblack(10,10,24);	bmap_fill(butt_over, vector(127,0,0), 100);
	BMAP* butt_over_off = bmap_createblack(10,10,24);	bmap_fill(butt_over_off, vector(127,0,127), 100);
	PANEL* mine = pan_create("size_x=100; size_y=90; flags=SHOW;",1);	
	mine.bmap = bmap_createblack(100,90,24);	bmap_fill(mine.bmap, vector(127,127,127), 100);
	pan_setbutton(mine,0,1,  7,7, butt_on, butt_off, butt_over, NULL, button_trigger_1,0,0);
		pan_setdigits(mine,0, 20,4, "<- PushButton", Arial_12, 0, 0);		
	pan_setbutton(mine,0,2,  7,27, butt_on, butt_off, butt_over, butt_over_off, button_trigger_1,0,button_trigger_2);
		pan_setdigits(mine,0, 20,24, "<- ToggleButton", Arial_12, 0, 0);		
	pan_setbutton(mine,0,4,  7,47, butt_on, butt_off, butt_over, butt_over_off, button_trigger_1,0,button_trigger_2);
	pan_setbutton(mine,0,4,  7,60, butt_on, butt_off, butt_over, butt_over_off, button_trigger_1,0,button_trigger_2);
	pan_setbutton(mine,0,4,  7,73, butt_on, butt_off, butt_over, butt_over_off, button_trigger_1,0,button_trigger_2);
		pan_setdigits(mine,0, 20,57, "<- RadioButtons", Arial_12, 0, 0);		
	//
	me = pan3d_create(mine, ang_rotate(vector(0,0,0),vector(20,-2,6)), NULL, FOLLOW_CAMERA|ORBIT_FOLLOW|FACE_FLAT);
	vec_fill(my.scale_x, 0.05);		my.material = mat_unlit;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
function main()
{
	video_switch(8,32,0);		level_load("pan3d_Demo.wmb");		wait(2);
	vec_set(sky_color.blue, vector(127,30,30));				diag("\n\n");
	mouse_mode = 4;				def_moveset();
	vec_set(camera.x, vector(-50,-100,100));					camera.pan=77;
	////////////////////////
	gui_A_action();	//show Player health bars
	gui_B_action();	//show Pseudo-Mini-Map panel
	gui_C_action();	//show Panel-with-buttons
}
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
